/**
 * qdb.h
 **/

#ifndef	_QDB_H
#define	_QDB_H				1

#define	QDB_BUCKETS			64
#define	QDB_SZKEY			1024*128
#define	QDB_SZVALUE			1024*256

#define	QDB_NULL			0xFFFFFFFF

#define	QDBERR_OK			0
#define	QDBERR_INIT			1
#define	QDBERR_NOTFOUND		2
#define	QDBERR_BADKEY		3
#define	QDBERR_BADVALUE		4
#define	QDBERR_OUTOFMEM		5
#define	QDBERR_FILEIO		6

typedef unsigned int uint;

typedef struct {
	uint	key;
	uint	value;
}pair_t;

typedef struct {
	pair_t	*pair;
	void	*next;
}qdblink_t;

typedef struct {
	char	*keys;
	uint	ofs_key;
	uint	sz_key;
	char	*values;
	uint	ofs_value;
	uint	sz_value;
	qdblink_t	*buckets;
	char	changed;
}qdb_t;

int		QDB_Init (uint szkey, uint szvalue);
int		QDB_Down ();
int		QDB_Error ();
int		QDB_Open (char *name);
int		QDB_Clear ();
int		QDB_Flush (char *name);
int		QDB_Close (char *name);
int		QDB_HasKey (char *key);
char	*QDB_Get (char *key);
float	QDB_GetF (char *key);
int		QDB_Put (char *key, char *value);
int		QDB_PutF (char *key, float value);
int		QDB_Remove (char *key);

#endif
