/**
 * strbuf.c
 **/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <math.h>

#include "strbuf.h"

char	*_strbuf = NULL;
char	*_ptr = NULL;

void	STRBUF_Init ()
{
	if (_strbuf)
	{
		free (_strbuf);
	}
	
	_strbuf = (char *)malloc (STRBUF_MAXSIZE);
	STRBUF_Clear ();	
}

void	STRBUF_Clear ()
{
	if (_strbuf)
	{
		memset (_strbuf, '\0', STRBUF_MAXSIZE);
	}
	
	_ptr = _strbuf;
}

void	STRBUF_Append (char *s)
{
	int	l, sz;
	
	if ((_strbuf) && (s))
	{
		l = strlen (s);
		sz = STRBUF_Free ();
		sz = (l <= sz ? l : sz);
		memcpy (_ptr, s, sz);
		_ptr += sz;
	}
}
void	STRBUF_AppendFloat (float *f)
{
	char	tmpbuf[64];
	int		i = (int) f[0];
	if (fabs(f[0]) - abs(i) >= 0.006f)
	{
		sprintf (tmpbuf, "%6.2f", f[0]);
	}
	else
	{
		sprintf (tmpbuf, "%i", i);
	}
	
	STRBUF_Append (tmpbuf);
}

char	*STRBUF_GetString ()
{
	if (_strbuf)
	{
		return strdup (_strbuf);
	}
	
	return NULL;
}

int		STRBUF_Length ()
{
	if (_strbuf)
	{
		return _ptr - _strbuf;
	}
	
	return -1;
}

int		STRBUF_Free ()
{
	if (_strbuf)
	{
		return STRBUF_MAXSIZE - (_ptr - _strbuf) - 1;
	}
	
	return 0;	
}
